proc read_hotkey_file {} {
	global CONFIGDIR
	if {![file exists $CONFIGDIR/hotkeys]} return
	set f [open $CONFIGDIR/hotkeys]
	set count 0
	while {[gets $f line]>=0} {
	   regsub {#.*$} $line {} command
	   if {[regexp {^\s*$} $command]} continue
	   if {[regexp {((Key|Mouse)\s+(\(\S+\))?\s*(\w+)\s+([ARWSDT\[\]-_F<^>vI0-9F]+)\s+([NCSMLA]+))\s+(\S.*$)} $command match keydescr k w key c m cmd]} {
			puts stderr "$keydescr SendToModule *fubar* $cmd"
	   		::fvwm::send "$keydescr SendToModule *fubar* $cmd"
			incr count
		} else {
			append errors "\nUnrecognized syntax: $line"
		}	
	}	
	close $f
	if {$count} {
		::fvwm::bind String interpet_hotkeys
		::fvwm::setMask {String}
	}	
	if {[info exists errors]} {
		after idle [list error $errors]
	}	

}

proc interpret_hotkeys {event_type id len message} {
  	set cmd hotkey_[string trim message]
	puts stderr "Hotkey $event_type $id $len $message"
	if [llength [info proc [lindex $cmd 0]]] {
		uplevel #0 $cmd
	} else {
		set widget .[lindex $message 0]
		if {![winfo exists $widget]} {
			return
		}
		switch {[winfo class $widget]} {
			Button -
			Menubutton {uplevel #0 $widget invoke}
			default {
				event generate $widget <Button-1>
			}
		}	
	}	
}

proc hotkey_menu {{menu_path {}}} {
	if {![string length $menu_path]} {
		.start invoke
	}	
}

proc hotkey_find {{menu_path {}}} {
	if {![string length $menu_path]} {
		.find invoke
	} else {
	  $find.m invoke $menu_path
	}  
}

